// -*- c++ -*-
// Generated by gmmproc 2.39.3 -- DO NOT MODIFY!
#ifndef _GTKMM_ACTIONBAR_H
#define _GTKMM_ACTIONBAR_H


#include <glibmm/ustring.h>
#include <sigc++/sigc++.h>

/*
 * Copyright (C) 2013 The gtkmm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <gtkmm/container.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GtkActionBar GtkActionBar;
typedef struct _GtkActionBarClass GtkActionBarClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gtk
{ class ActionBar_Class; } // namespace Gtk
namespace Gtk
{

/** A box with a centered child.
 *
 * Gtk::ActionBar is similar to a horizontal Gtk::Box, it allows to place
 * children at the start or the end. In addition, it contains an
 * internal centered box which is centered with respect to the full
 * width of the box, even if the children at either side take up
 * different amounts of space.
 *
 * @ingroup Containers
 * @newin{3,12}
 */

class ActionBar
  : public Container
{
  public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef ActionBar CppObjectType;
  typedef ActionBar_Class CppClassType;
  typedef GtkActionBar BaseObjectType;
  typedef GtkActionBarClass BaseClassType;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

  virtual ~ActionBar();

#ifndef DOXYGEN_SHOULD_SKIP_THIS

private:
  friend class ActionBar_Class;
  static CppClassType actionbar_class_;

  // noncopyable
  ActionBar(const ActionBar&);
  ActionBar& operator=(const ActionBar&);

protected:
  explicit ActionBar(const Glib::ConstructParams& construct_params);
  explicit ActionBar(GtkActionBar* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:

  /** Get the GType for this class, for use with the underlying GObject type system.
   */
  static GType get_type()      G_GNUC_CONST;

#ifndef DOXYGEN_SHOULD_SKIP_THIS


  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GtkObject.
  GtkActionBar*       gobj()       { return reinterpret_cast<GtkActionBar*>(gobject_); }

  ///Provides access to the underlying C GtkObject.
  const GtkActionBar* gobj() const { return reinterpret_cast<GtkActionBar*>(gobject_); }


public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::


private:

public:

  /** Creates a new ActionBar widget.
   */
  ActionBar();

  
  /** Adds @a child to @a box, packed with reference to the
   * start of the @a box.
   * 
   * @newin{3,12}
   * @param child The Gtk::Widget to be added to @a bar.
   */
  void pack_start(Gtk::Widget& child);
  
  /** Adds @a child to @a box, packed with reference to the
   * end of the @a box.
   * 
   * @newin{3,12}
   * @param child The Gtk::Widget to be added to @a bar.
   */
  void pack_end(Gtk::Widget& child);

  // transfer none
  
  /** Retrieves the center box widget of the bar.
   * 
   * @newin{3,12}
   * @return The center Gtk::Box.
   */
  Widget* get_center_widget();
  
  /** Retrieves the center box widget of the bar.
   * 
   * @newin{3,12}
   * @return The center Gtk::Box.
   */
  const Widget* get_center_widget() const;
  
  /** Sets the center widget for the Gtk::ActionBar.
   * 
   * @newin{3,12}
   * @param center_widget A widget to use for the center.
   */
  void set_center_widget(Widget& center_widget);

  #ifdef GLIBMM_PROPERTIES_ENABLED
/** The amount of space between children.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy< int > property_spacing() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** The amount of space between children.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy_ReadOnly that allows you to get the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< int > property_spacing() const;
#endif //#GLIBMM_PROPERTIES_ENABLED

  #ifdef GLIBMM_PROPERTIES_ENABLED
/** Widget to display in center.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy< Widget* > property_center_widget() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** Widget to display in center.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy_ReadOnly that allows you to get the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< Widget* > property_center_widget() const;
#endif //#GLIBMM_PROPERTIES_ENABLED


  // Gtk::ActionBar has no signals nor vfuncs as of 3.12.


};

} // namespace Gtk


namespace Glib
{
  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates Gtk::ActionBar
   */
  Gtk::ActionBar* wrap(GtkActionBar* object, bool take_copy = false);
} //namespace Glib


#endif /* _GTKMM_ACTIONBAR_H */

